/*  PS2Keyboard library example
  
  PS2Keyboard now requries both pins specified for begin()

  keyboard.begin(data_pin, irq_pin);
  
  Valid irq pins:
     Arduino:      2, 3
     Arduino Mega: 2, 3, 18, 19, 20, 21
     Teensy 1.0:   0, 1, 2, 3, 4, 6, 7, 16
     Teensy 2.0:   5, 6, 7, 8
     Teensy++ 1.0: 0, 1, 2, 3, 18, 19, 36, 37
     Teensy++ 2.0: 0, 1, 2, 3, 18, 19, 36, 37
     Sanguino:     2, 10, 11
  
  for more information you can read the original wiki in arduino.cc
  at http://www.arduino.cc/playground/Main/PS2Keyboard
  or http://www.pjrc.com/teensy/td_libs_PS2Keyboard.html
  
  Like the Original library and example this is under LGPL license.
  
  Modified by Cuninganreset@gmail.com on 2010-03-22
  Modified by Paul Stoffregen <paul@pjrc.com> June 2010
*/
   
#include <PS2Keyboard.h>
#include <NewSoftSerial.h>
const int kDataPin = 4;
const int kIrqPin =  2;
const int xDataPin = 5;
const int xIrqPin =  3;
char k,s,x;

PS2Keyboard keyboard;
NewSoftSerial xBee =  NewSoftSerial(xIrqPin, xDataPin);

void setup() {
  delay(1000);
  keyboard.begin(kDataPin, kIrqPin);
  Serial.begin(115200);
  Serial.println("Keyboard Master:");
  xBee.begin(9600);
  xBee.println("xBeeMaster...");
}
void loop() {
  if (Serial.available()) {
    s = (char)Serial.read();
    Serial.print("Serial in: ");   Serial.println(s); xBee.print(s);
  }
  if (keyboard.available()) {
    k = (char)keyboard.read();
    Serial.print("Keyboard in: "); Serial.println(k); xBee.print(k);
  }
  if (xBee.available()) {
    x = (char)xBee.read();
    Serial.print("xBee in: ");     Serial.println(x);
  }
  delay(100);
}
