#include "TFTLCD.h"

#define LCD_CS A3    // Chip Select goes to Analog 3
#define LCD_CD A2    // Command/Data goes to Analog 2
#define LCD_WR A1    // LCD Write goes to Analog 1
#define LCD_RD A0    // LCD Read goes to Analog 0
#define LCD_RESET A4

#define	BLACK               0 //0x0000
#define	BLUE               31 //0x001F
#define	GREEN            2016 //0x07E0
#define CYAN             2047 //0x07FF
#define	RED             63488 //0xF800
#define MAGENTA         63519 //0xF81F
#define YELLOW          65504 //0xFFE0 
#define WHITE           65535 //0xFFFF

TFTLCD tft(LCD_CS, LCD_CD, LCD_WR, LCD_RD, LCD_RESET);

void setup()
{
  Serial.begin(115200);
  Serial.println("tftKeyboardxBee...");
 
  tft.reset();
  uint16_t identifier = tft.readRegister(0x0);
  if (identifier == 0x9325) {
    Serial.println("Found ILI9325");
  } else if (identifier == 0x9328) {
    Serial.println("Found ILI9328");
  } else {
    Serial.print("Unknown driver chip ");
    Serial.println(identifier, HEX);
    while (1);
  }  
  tft.initDisplay();
  tft.fillScreen(BLACK);
  box(40, 100, 140, 35, 2047, 2016, 2078, 2, 3, "Your momma");
}

void box(int x, int y, int h, int w,
  int boxBorderColor, int boxFillColor,
  int textColor, int textSize, int textRotation,
  String textText){
  tft.drawRect(x+0, y+0, w-0, h-0, boxBorderColor);
  tft.fillRect(x+1, y+1, w-2, h-2, boxFillColor);
  tft.drawRect(x+2, y+2, w-4, h-4, boxBorderColor);
  tft.setCursor(320-h-y+10, x+10);
  tft.setRotation(textRotation);
  tft.setTextColor(textColor);
  tft.setTextSize(textSize);
  tft.println(textText);
  tft.setRotation(0);
}

void loop(){
}
